;---------------------------------------------------------
; 9-band digital spectral sound  analyzer + clock
; 
; copyright(c)Veselin Koev 2002 y.
; 
;      Author does not take any responsibility of possible
;damage caused by using this program and attached hardware.
;use it at your own risk!
;----------------------------------------------------------


.include "2313def.inc"
.listmac
.def	wl		=r0
.def	wh		=r1

.def	y10		=r2

.def	adc		=r3

.def	y11l		=r4
.def	y11h		=r5
.def	y21l		=r6
.def	y21h		=r7
.def	y12l		=r8
.def	y12h		=r9
.def	y22l		=r10
.def	y22h		=r11

.def	y13l		=r12
.def	y13h		=r13
.def	y23l		=r14
.def	y23h		=r15

.def	yd1l		=r16
.def	yd1m		=r17
.def	yd1h		=r18
.def	yd2l		=r19
.def	yd2m		=r20
.def	yd2h		=r21

.def	temp0		=r22
.def	y1l		=r22
.def	temp1		=r23
.def	y1m		=r23
.def	temp2		=r24
.def	y1h		=r24
.def	temp3		=r25

.def	y2l		=r26
.def	y2m		=r30
.def	y2h		=r31

.def	xl		=r26
.def	xh		=r27
.def	yl		=r28
.def	yh		=r29
.def	zl		=r30
.def	zh		=r31

;displacements for RAM locations :

;RAM bank0  $60
.equ	ypl		=0
.equ	ypm		=1
.equ	yph		=2
.equ	d1l		=3
.equ	d1h		=4
.equ	d2l		=5
.equ	d2h		=6
.equ	dxl		=7
.equ	dxh		=8
.equ	dwl		=9
.equ	dwm		=10
.equ	dwh		=11
.equ	dsuml		=12
.equ	dsumh		=13
.equ	y15l		=14
.equ	y15h		=15
.equ	y25l		=16
.equ	y25h		=17
.equ	y16l		=18
.equ	y16h		=19
.equ	y26l		=20
.equ	y26h		=21
.equ	y17l		=22
.equ	y17m		=23
.equ	y17h		=24
.equ	y27l		=25
.equ	y27m		=26
.equ	y27h		=27
.equ	y18l		=28
.equ	y18m		=29
.equ	y18h		=30
.equ	y28l		=31
.equ	y28m		=32
.equ	y28h		=33
.equ	peac0		=34
.equ	peac1		=35
.equ	peac2		=36
.equ	peac3		=37
.equ	peac4		=38
.equ	peac5		=39
.equ	peac6		=40
.equ	peac7		=41
.equ	peac8		=42
.equ	adc_r		=43
.equ	block_index	=44
.equ	dot_w		=45
.equ	d8_index	=46
.equ	d_peac8		=47
.equ	d_peac7		=48
.equ	d_peac6		=49
.equ	d_peac5		=50
.equ	d_peac4		=51
.equ	d_peac3		=52
.equ	d_peac2		=53
.equ	d_peac1		=54
.equ	d_peac0		=55
.equ	col_index	=56
.equ	timel		=57
.equ	timem		=58
.equ	timeh		=59
.equ	minutes		=60
.equ	hours		=61
.equ	key		=62
.equ	k_delay		=63

;RAM bank1  $A0

.macro add16
		add	@1,@3
		adc	@0,@2
.endmacro

.macro adc16
		adc	@1,@3
		adc	@0,@2
.endmacro

.macro sub16
		sub	@1,@3
		sbc	@0,@2
.endmacro

.macro sbc16
		sbc	@1,@3
		sbc	@0,@2
.endmacro


		.CSEG

rst:		.org	$0000
		cli
		ldi	temp1,0x00
		out	portb,temp1
		ldi	temp1,0x74
		rjmp	reset
ovf1:		cbi	ddrb,pb1		;start ADC
		push	wl
		push	temp0
		push	temp1
		rjmp	dsp			;DSP handle(continue)
adcfin:		in	adc,tcnt0
		set
		reti
dB_tab:		.dw	0b0000000000000000	; 1	 0
		.dw	0b0000000000000000	; 3	 2
		.dw	0b0000000100000000	; 5	 4
		.dw	0b0000001100000001	; 7	 6
		.dw	0b0000011100000011	; 9	 8
		.dw	0b0000011100000111	;11	10
		.dw	0b0000111100001111	;13	12
		.dw	0b0001111100001111	;15	14
		.dw	0b0001111100011111	;17	16
		.dw	0b0011111100011111	;19	18
		.dw	0b0011111100111111	;21	20
		.dw	0b0011111100111111	;23	22
		.dw	0b0111111101111111	;25	24
		.dw	0b0111111101111111	;27	26
		.dw	0b0111111101111111	;29	28
		.dw	0b1111111111111111	;31	30

char_tab:	.dw	0x413E,0x4141,0x003e	;"O"
		.dw	0x4000,0x427f,0x0000	;"1"
		.dw	0x4946,0x6151,0x0042	;"2"
		.dw	0x4B31,0x4145,0x0021	;"3"
		.dw	0x7F10,0x1412,0x0018	;"4"
		.dw	0x4538,0x4545,0x0027	;"5"
		.dw	0x4930,0x4A49,0x003C	;"6"
		.dw	0x0503,0x7109,0x0001	;"7"
		.dw	0x4936,0x4949,0x0036	;"8"
		.dw	0x493E,0x4949,0x0006	;"9"
		.dw	0x0000,0x3636,0x0000	;":"

bk:		.dw	0b0010000000011010	; b8k  b16k
		.dw	0b0001010000011111	; b2k  b4k
		.dw	0b0001111100010110	; b500 b1k
		.dw	0b0001011000010100	; b125 b250
		.dw	0b0000000000010010	;      b63

dsp:		push	temp2
		push	temp3
		in	wl,sreg
		push	wl
		push	zl
		push	zh
		clt
		ldd	xh,y+adc_r
		sub	xh,adc			;non-recursive part of filters 16k 8k 4k 2k
		std	y+adc_r,adc
		mov	y1m,adc
		in	temp3,tcnt0
		subi	temp3,0x77
D8A2:						;recursive part of decimaton filter D8
		clr	y1h			; & recursive part of filter 1k
		sbrc	y1m,7
		com	y1h

		clr	y1l
		sub	y1l,yd2l
		sbc	y1m,yd2m
		sbc	y1h,yd2h
D8A1:		sei				;31 clocks

		add	y1l,yd1l		;a1 h(1)
		adc	y1m,yd1m
		adc	y1h,yd1h
		asr	yd1h
		ror	yd1m
		ror	yd1l
		mov	yd2l,yd1l		;a2 l(7)
		mov	yd2m,yd1m
		mov	yd2h,yd1h
		asr	yd1h
		ror	yd1m
		ror	yd1l
		add	yd2l,yd1l		;a2 l(6)
		adc	yd2m,yd1m
		adc	yd2h,yd1h
		asr	yd1h
		ror	yd1m
		ror	yd1l
		asr	yd1h
		ror	yd1m
		ror	yd1l
		add	yd2l,yd1l		;a2 l(4)
		adc	yd2m,yd1m
		adc	yd2h,yd1h
		add	temp0,yd2l		;a1 l(7,6,4)
		adc	y1m,yd2m
		adc	y1h,yd2h
		asr	yd1h
		ror	yd1m
		ror	yd1l
		add	yd2l,yd1l		;a2 l(3)
		adc	yd2m,yd1m
		adc	yd2h,yd1h

		mov	yd1l,y1l
		mov	yd1m,y1m
		mov	yd1h,y1h
		ldd	wl,y+ypm
		ldd	wh,y+yph
		std	y+ypm,yd1m
		std	y+yph,yd1h

		sub16	wh,wl,y1h,y1m		;non recursive part of filter 1k
		asr	wh
		ror	wl
	;	asr	wh
	;	ror	wl
		ldd	temp0,y+peac4
		cp	temp0,wl
		brge	great4
		inc	temp0
great4:		std	y+peac4,temp0

		ldd	wl,y+dsuml		;non recursive part of decimaton filter D8
		ldd	wh,y+dsumh
	;	asr	y1h
	;	ror	y1m
		add	wl,y1m
		adc	wh,y1h
		std	y+dsuml,wl
		std	y+dsumh,wh

		ldd	temp1,y+d8_index	;after decimation, 1 case of 8 parts
		inc	temp1
		cbr	temp1,0xf8
		std	y+d8_index,temp1
		ldi	zl,low(D8_tab)
		ldi	zh,high(D8_tab)
		add	zl,temp1
		adc	zh,yh
		ijmp
D8_tab:		rjmp	D8_0			;part0
		rjmp	D8_1
		rjmp	D8_2
		rjmp	D8_3
		rjmp	D8_4
		rjmp	D8_5			;part5
		rjmp	D8_6			;part6
D8_7:						;part7
		ldd	y1h,y+dsumh		; 54 - 2 = 52 clokcs
		ldd	y1l,y+dsuml
		std	y+dsumh,yh
		std	y+dsuml,yh
		ldd	wh,y+d2h
		ldd	wl,y+d2l
		sub16	wh,wl,y1h,y1l		;non recursive part of filters 500,250,125,63
		asr	wh
		ror	wl
		std	y+dxh,wh
		std	y+dxl,wl
		ldd	wh,y+d1h
		ldd	wl,y+d1l
		std	y+d2h,wh
		std	y+d2l,wl
		std	y+d1h,y1h
		std	y+d1l,y1l
		ldd	wh,y+y16h		;peac of filter 250
		ldd	temp0,y+peac6
		cp	temp0,wh
		brge	great6
		mov	temp0,wh
great6:		std	y+peac6,temp0
		ldd	wh,y+y18h		;peac of filter 63
	;	asr	wh
		sbrc	wh,7
		neg	wh
		ldd	temp0,y+peac8
		cp	temp0,wh
		brge	great8
		mov	temp0,wh
great8:		std	y+peac8,temp0
		rjmp	D8end
D8_0:
		ldd	y1h,y+y15h		;51 clocks
		ldd	y1l,y+y15l
		ldd	y2h,y+y25h
		ldd	y2l,y+y25l
		ldd	wh,y+dxh
		ldd	wl,y+dxl
	;	lsl	wl
	;	rol	wh
F500A2:
		sub16	wh,wl,y2h,y2l		;2

F500A1:
		add16	wh,wl,y1h,y1l		;18 CLOCKS
		asr	y1h
		ror	y1l
		mov	y2h,y1h
		mov	y2l,y1l
		asr	y1h
		ror	y1l
		asr	y1h
		ror	y1l
		add16	wh,wl,y1h,y1l
		asr	y1h
		ror	y1l
		asr	y1h
		ror	y1l
		add16	y2h,y2l,y1h,y1l

		std	y+y15h,wh
		std	y+y15l,wl
		std	y+y25h,y2h
		std	y+y25l,y2l
		ldd	temp0,y+peac5
		cp	temp0,wh
		brge	great5
		mov	temp0,wh
great5:		std	y+peac5,temp0
		rjmp	D8end
D8_1:						;50 clocks
		ldd	y1h,y+y16h
		ldd	y1l,y+y16l
		ldd	y2h,y+y26h
		ldd	y2l,y+y26l
		ldd	wh,y+dxh
		ldd	wl,y+dxl
	;	asr	wh
	;	ror	wl
F250A2:
		sub16	wh,wl,y2h,y2l
F250A1:
		add16	wh,wl,y1h,y1l		;24 CLOCKS
		asr	y1h
		ror	y1l
		add16	wh,wl,y1h,y1l
		mov	y2h,y1h
		mov	y2l,y1l
		asr	y1h
		ror	y1l
		add16	y2h,y2l,y1h,y1l
		asr	y1h
		ror	y1l
		asr	y1h
		ror	y1l
		add16	wh,wl,y1h,y1l
		asr	y1h
		ror	y1l
		sub16	y2h,y2l,y1h,y1l
		add16	wh,wl,y1h,y1l

		std	y+y16h,wh
		std	y+y16l,wl
		std	y+y26h,y2h
		std	y+y26l,y2l
		rjmp	D8end

D8_2:						;52 clocks
		ldd	y1l,y+y17l
		ldd	y1m,y+y17m
		ldd	y1h,y+y17h
		ldd	wl,y+y27l
		ldd	yd1m,y+y27m
		ldd	wh,y+y27h
F125A1:
		add	wl,y1l			;a1 h(1)
		adc	yd1m,y1m
		adc	wh,y1h
		asr	y1h
		ror	y1m
		ror	y1l
		mov	y2l,y1l			;a2 l(7)
		mov	y2m,y1m
		mov	y2h,y1h
		asr	y1h
		ror	y1m
		ror	y1l
		add	y2l,y1l			;a2 l(6)
		adc	y2m,y1m
		adc	y2h,y1h
		asr	y1h
		ror	y1m
		ror	y1l
		std	y+y17l,y1l
		std	y+y17m,y1m
		std	y+y17h,y1h
		std	y+y27l,y2l
		std	y+y27m,y2m
		std	y+y27h,y2h
		std	y+dwl,wl
		std	y+dwm,yd1m
		std	y+dwh,wh
		ldd	yd1m,y+ypm
		rjmp	D8end
D8_3:						;49 clocks
		ldd	y1l,y+y17l		;F125 - continue
		ldd	y1m,y+y17m
		ldd	y1h,y+y17h
		ldd	y2l,y+y27l
		ldd	y2m,y+y27m
		ldd	y2h,y+y27h
		ldd	wl,y+dwl
		ldd	yd1m,y+dwm
		ldd	wh,y+dwh
		asr	y1h
		ror	y1m
		ror	y1l
		add	y2l,y1l			;a2 l(4)
		adc	y2m,y1m
		adc	y2h,y1h
		add	wl,y2l			;a1 l(7,6,4)
		adc	yd1m,y2m
		adc	wh,y2h
		asr	y1h
		ror	y1m
		ror	y1l
		add	y2l,y1l			;a2 l(3)
		adc	y2m,y1m
		adc	y2h,y1h
		std	y+y17l,wl
		std	y+y17m,yd1m
		std	y+y17h,wh
		std	y+y27l,y2l
		std	y+y27m,y2m
		std	y+y27h,y2h
		ldd	yd1m,y+ypm
		rjmp	D8end
D8_4:						;53 clokcs
		ldd	wh,y+y17h		;peac of filter 125
	;	asr	wh
		ldd	temp0,y+peac7
		cp	temp0,wh
		brge	great7
		mov	temp0,wh
great7:		std	y+peac7,temp0
		ldd	wh,y+dxh
		ldd	wl,y+dxl
		asr	wh
		ror	wl
		mov	y1m,wl
		mov	y1h,wh
F125A2:		ldd	y2l,y+y27l
		ldd	y2m,y+y27m
		ldd	y2h,y+y27h
		neg	y2l
		sbc	y1m,y2m
		sbc	y1h,y2h
		std	y+y27l,y2l		;y27=x-a2*y(-1)
		std	y+y27m,y1m
		std	y+y27h,y1h
		asr	wh
		ror	wl
		asr	wh
		ror	wl
F63A2:		ldd	y2l,y+y28l
		ldd	y2m,y+y28m
		ldd	y2h,y+y28h
		neg	y2l
		sbc	wl,y2m
		sbc	wh,y2h
		std	y+y28l,y2l		;y28=x-a2*y(-1)
		std	y+y28m,wl
		std	y+y28h,wh
		rjmp	D8end
D8_5:						;52 clocks
		ldd	y1m,y+y18m
		ldd	y1h,y+y18h
		ldd	wl,y+y28l
		ldd	yd1m,y+y28m
		ldd	wh,y+y28h
F63A1:
		clr	y1l
		sbrc	y1h,7
		com	y1l
		asr	wh			;a1=a1/2
		ror	yd1m
		ror	wl
		sub	wl,y1m			;a1 l(0)
		sbc	yd1m,y1h
		sbc	wh,y1l
		ldd	y1l,y+y18l
		add	wl,y1l			;a1 h(1)
		adc	yd1m,y1m
		adc	wh,y1h
		mov	y2l,y1l			;a2 h(1)
		mov	y2m,y1m
		mov	y2h,y1h
		asr	y1h
		ror	y1m
		ror	y1l

		std	y+y18l,y1l
		std	y+y18m,y1m
		std	y+y18h,y1h
		std	y+y28l,y2l
		std	y+y28m,y2m
		std	y+y28h,y2h
		std	y+dwl,wl
		std	y+dwm,yd1m
		std	y+dwh,wh
		ldd	yd1m,y+ypm
		rjmp	D8end
D8_6:						;55 - 2 = 53 clocks
		ldd	y1l,y+y18l		;F63A1 - continue
		ldd	y1m,y+y18m
		ldd	y1h,y+y18h
		ldd	y2l,y+y28l
		ldd	y2m,y+y28m
		ldd	y2h,y+y28h
		ldd	wl,y+dwl
		ldd	yd1m,y+dwm
		ldd	wh,y+dwh

		asr	y1h
		ror	y1m
		ror	y1l
		asr	y1h
		ror	y1m
		ror	y1l
		asr	y1h
		ror	y1m
		ror	y1l
		sub	y2l,y1l			;a2 l(4)
		sbc	y2m,y1m
		sbc	y2h,y1h
		asr	y1h
		ror	y1m
		ror	y1l
		sub	wl,y1l			;a1 l(3)
		sbc	yd1m,y1m
		sbc	wh,y1h
		lsl	wl			;a1=a1*2
		rol	yd1m
		rol	wh

		std	y+y18l,wl
		std	y+y18m,yd1m
		std	y+y18h,wh
		std	y+y28l,y2l
		std	y+y28m,y2m
		std	y+y28h,y2h
		ldd	yd1m,y+ypm
	;	rjmp	D8end

D8end:
F16KA1:		clr	xl
	;	asr	xh
	;	ror	xl
	;	asr	xh
	;	ror	xl
		mov	wh,xh
	;	asr	wh
		asr	y10			;16 CLOCKS
		asr	y10
		sub	wh,y10

		mov	y10,wh			;10/11 clocks
	;	lsl	wh
		ldd	temp0,y+peac0
		cp	temp0,wh
		brge	great0
		inc	temp0
great0:		std	y+peac0,temp0
	;	asr	xh
	;	ror	xl
		mov	wl,xl
		mov	wh,xh		
F8KA2:
		sub16	wh,wl,y21h,y21l

		asr	y11h
		ror	y11l
		mov	y21h,y11h
		mov	y21l,y11l
		asr	y11h
		ror	y11l
		asr	y11h
		ror	y11l
		asr	y11h
		ror	y11l
		sub16	y21h,y21l,y11h,y11l
		add16	wh,wl,y21h,y21l

		mov	y11l,wl			;9/10 clocks
		mov	y11h,wh
		ldd	temp0,y+peac1
		cp	temp0,wh
		brge	great1
		inc	temp0
great1:		std	y+peac1,temp0
	;	asr	xh
	;	ror	xl
		mov	wl,xl
		mov	wh,xh

F4KA2:
		sub16	wh,wl,y22h,y22l		;2

F4KA1:
		add16	wh,wl,y12h,y12l		;18 CLOCKS
		asr	y12h
		ror	y12l
		mov	y22h,y12h
		mov	y22l,y12l
		asr	y12h
		ror	y12l
		asr	y12h
		ror	y12l
		add16	wh,wl,y12h,y12l
		asr	y12h
		ror	y12l
		asr	y12h
		ror	y12l
		add16	y22h,y22l,y12h,y12l
		mov	y12l,wl
		mov	y12h,wh
		tst	wh
		ldd	temp0,y+peac2
		cp	temp0,wh
		brge	great2
		inc	temp0
great2:		std	y+peac2,temp0

	;	asr	xh
	;	ror	xl
		mov	wl,xl
		mov	wh,xh

F2KA2:
		sub16	wh,wl,y23h,y23l
F2KA1:
		add16	wh,wl,y13h,y13l		;24 CLOCKS
		asr	y13h
		ror	y13l
		add16	wh,wl,y13h,y13l
		mov	y23h,y13h
		mov	y23l,y13l
		asr	y13h
		ror	y13l
		add16	y23h,y23l,y13h,y13l
		asr	y13h
		ror	y13l
		asr	y13h
		ror	y13l
		add16	wh,wl,y13h,y13l
		asr	y13h
		ror	y13l
		sub16	y23h,y23l,y13h,y13l
		add16	wh,wl,y13h,y13l

		mov	y13l,wl			;9/10 clocks
		mov	y13h,wh
		ldd	temp0,y+peac3
		cp	temp0,wh
		brge	great3
		mov	temp0,wh
great3:		std	y+peac3,temp0

	;	in	adc,pinb		;simulator only!
		cli
		brtc	next			;real circuit only!
		sub	adc,temp3		;real circuit only!
	;	asr	adc
		asr	adc
next:		sbi	ddrb,pb1		;start discharge
		pop	zh
		pop	zl
		pop	wl
		pop	temp3
		inc	temp3
		pop	temp2
		pop	temp1
		pop	temp0
		out	sreg,wl
		pop	wl
		wdr
		set
		reti



reset:		out	portd,temp1
		clr	adc
		ldi	temp1,0x08
		out	wdtcr,temp1
		ldi	temp1,0xfe
		out	ddrb,temp1		;real only !
		ldi	temp1,0x0b
		out	ddrd,temp1
		ldi	temp1,0xdf
		out	SPL,temp1
		ldi	temp1,0x81
		out	tccr1a,temp1
		clr	temp1
		out	ocr1ah,temp1
		ldi	temp1,0x30		;PWM value
		out	ocr1al,temp1
		ldi	temp1,0x01
		out	tccr0,temp1
		out	tccr1b,temp1
		ldi	temp1,0x02
		out	mcucr,temp1
		ldi	temp1,0x80
		out	timsk,temp1
		ldi	temp1,0x0a
		out	acsr,temp1
		ldi	yl,$60
		clr	yh
		ldi	temp1,0x12
		std	y+hours,temp1
		std	y+minutes,yh
		ldi	temp1,0x30
		std	y+dot_w,temp1
		ldi	temp1,0xff
		std	y+key,temp1
		ldi	temp1,0x43		;one minute
		std	y+timem,temp1		;32000 * 60 = 1920000 =0x1D4C00
		ldi	temp1,0xe3		;0x1000000 - 0x1D4C00 = 0xE2B400
		std	y+timeh,temp1
		sei
start:

index:		in	temp1,gifr
		andi	temp1,0x40
		breq	i4
		out	gifr,temp1
		ldd	temp1,y+dot_w
		sub	temp0,temp1
		brcs	i1
		cpi	temp0,20
		brcs	i2
		inc	temp1
	;	brne	i2
	;	dec	temp1
		rjmp	i2
i1:		cpi	temp0,-2
		brcc	i2
		dec	temp1
	;	brne	i2
	;	inc	temp1
i2:		ldi	temp0,0x01
		std	y+block_index,yh
		std	y+dot_w,temp1
i4:		ldd	temp1,y+timel
		std	y+timel,temp3
		cp	temp3,temp1
		brcc	d
		ldd	temp1,y+timem
		inc	temp1
		std	y+timem,temp1
		brne	d
		ldd	temp1,y+timeh
		inc	temp1
		brne	t2
		subi	temp3,-0x7B
		ldi	temp1,0x43		;one minute
		std	y+timem,temp1		;32000 * 60 = 1920000 =0x1D4C00
		rcall	inc_mins
		ldi	temp1,0xe3		;0x1000000 - 0x1D4C00 = 0xE2B400
t2:		std	y+timeh,temp1

d:		ldd	temp1,y+block_index
		ldi	zh,high(d_begin)
		ldi	zl,low(d_begin)
		add	zl,temp1
		adc	zh,yh
		ijmp
d_begin:	rjmp	calc
		rjmp	delay
		rjmp	init_disp
		rjmp	disp
		rjmp	delay
		rjmp	minutes_l
		rjmp	minutes_h
		rjmp	m_h_separ
		rjmp	hours_l
		rjmp	hours_h
		inc	temp0
		brne	time
		dec	temp0
time:		ldd	temp1,y+k_delay
		cpse	temp1,yh
		rjmp	key_delay
		in	temp1,pind			;check keys
		ldd	zl,y+key
		mov	zh,temp1
		eor	zh,zl
		and	zh,temp1
		std	y+key,temp1
		sbrc	zh,4
		rcall	inc_hours
		sbrc	zh,5
		rcall	inc_tenm
		sbrc	zh,6
		rcall	inc_mins
		andi	zh,0b01110000
		breq	k1
		ldi	temp1,0xff
		std	y+k_delay,temp1
k1:		ldi	temp1,0x03
		rjmp	loop3
key_delay:	dec	temp1
		std	y+k_delay,temp1
		ldi	temp1,0x20
		rjmp	loop3

calc:		ldd	temp1,y+peac0
mul16k:		mov	temp2,temp1
		asr	temp1
		asr	temp1
		add	temp1,temp2
		asr	temp1
		add	temp1,temp2
		asr	temp1
		cpi	temp1,0x20
		brlo	m1
		rcall	overflow
		clr	y10
m1:		std	y+d_peac0,temp1
		std	y+peac0,yh
		ldd	temp1,y+peac1
		cpi	temp1,0x20
		brlo	m2
		rcall	overflow
		clr	y11h
m2:		std	y+d_peac1,temp1
		std	y+peac1,yh
		ldd	temp1,y+peac2
		cpi	temp1,0x20
		brlo	m3
		rcall	overflow
		clr	y12h
m3:		std	y+d_peac2,temp1
		std	y+peac2,yh
		ldd	temp1,y+peac3
mul2k:		mov	temp2,temp1
		asr	temp1
		asr	temp1
		add	temp1,temp2
		asr	temp1
		cpi	temp1,0x20
		brlo	m4
		rcall	overflow
		clr	y13h
m4:		std	y+d_peac3,temp1
		std	y+peac3,yh
		ldd	zl,y+peac4
mul1k:		mov	temp2,zl
		asr	zl
		add	zl,temp2
		asr	zl
		asr	zl
		add	zl,temp2
		asr	zl
		cpi	zl,0x20
		brlo	m5
		rcall	overflow
		clr	yd1h
		mov	zl,temp1
m5:		std	y+d_peac4,zl
		std	y+peac4,yh
		asr	zl
		ldd	temp1,y+peac5
		cp	zl,temp1
		brmi	c1
		mov	temp1,zl
c1:		cpi	temp1,0x20
		brlo	m6
		rcall	overflow
		std	y+y15h,yh
m6:		std	y+d_peac5,temp1
		std	y+peac5,yh
		asr	zl
		ldd	temp1,y+peac6
mul250:		mov	temp2,temp1
		asr	temp1
		asr	temp1
		add	temp1,temp2
		asr	temp1
		cp	zl,temp1
		brmi	c2
		mov	temp1,zl
c2:		cpi	temp1,0x20
		brlo	m7
		rcall	overflow
		std	y+y16h,yh
m7:		std	y+d_peac6,temp1
		std	y+peac6,yh
		asr	zl
		ldd	temp1,y+peac7
mul125:		mov	temp2,temp1
		asr	temp1
		add	temp1,temp2
		asr	temp1
		asr	temp1
		add	temp1,temp2
		asr	temp1
		cp	zl,temp1
		brmi	c3
		mov	temp1,zl
c3:		cpi	temp1,0x20
		brlo	m8
		rcall	overflow
		std	y+y17h,yh
m8:		std	y+d_peac7,temp1
		std	y+peac7,yh
		asr	zl
		ldd	temp1,y+peac8
mul63:		mov	temp2,temp1
		asr	temp1
		asr	temp1
		asr	temp1
		add	temp1,temp2
		cp	zl,temp1
		brmi	c4
		mov	temp1,zl
c4:		cpi	temp1,0x20
		brlo	m9
		rcall	overflow
		std	y+y18h,yh
m9:		std	y+d_peac8,temp1
		std	y+peac8,yh
		ldi	temp2,0x01
		std	y+block_index,temp2
		in	temp1,ocr1al
		subi	temp1,1
		brlo	m10
		out	ocr1ah,yh
		out	ocr1al,temp1
m10:		ldi	temp2,0x02		;delay value1
		ldd	temp1,y+dot_w
		lsr	temp1
	;	lsr	temp1
		rjmp	loop3

overflow:	in	temp1,ocr1al
		inc	temp1
		breq	o1
		inc	temp1
		breq	o1
		out	ocr1ah,yh
		out	ocr1al,temp1
		ldi	temp1,0x1f
o1:		ret
init_disp:	ldi	temp2,0x60+d_peac8
		rjmp	inc_block
disp:		clr	zh
		mov	zl,temp2
		inc	temp2
		cpi	temp2,0x61+d_peac0
		brne	d1
		ldi	temp1,4
		std	y+block_index,temp1
		ldi	temp2,0x05		;delay value2
d1:		ld	temp1,z
		ldi	zl,low(2*dB_tab)
		add	zl,temp1
		lpm
		mov	zl,wl
		mov	temp1,zl
		cbr	temp1,0x0b
		sbr	zl,0x74
		clt
		brtc	PC
		out	portb,temp1
		out	portd,zl
		ldd	temp1,y+dot_w
		lsr	temp1
		lsr	temp1
	;	inc	temp1
	;	ldi	temp1,0x12
loop2:		clt
		brtc	PC		
		dec	temp1
		brne	loop2
		clr	temp1
		out	portb,temp1
		sbr	temp1,0x74
		out	portd,temp1
loop4:		ldd	temp1,y+dot_w
		lsr	temp1
		lsr	temp1
	;	inc	temp1
	;	ldi	temp1,0x14
loop3:		clt
		brtc	PC		
		dec	temp1
		brne	loop3
		rjmp	start
delay:		dec	temp2
		brne	del1
		ldd	temp1,y+block_index
		inc	temp1
		std	y+block_index,temp1
del1:		ldd	temp1,y+dot_w
		rjmp	loop3

hours_l:	ldd	temp1,y+hours
		rjmp	ml2
hours_h:	ldd	temp1,y+hours
		cpi	temp1,10
		brcc	ml1
		clr	zl
		ldd	temp1,y+col_index
		rjmp	disp_digit
m_h_separ:	ldi	temp1,10
		rjmp	ml2
minutes_l:	ldd	temp1,y+minutes
		rjmp	ml2
minutes_h:	ldd	temp1,y+minutes
ml1:		swap	temp1
ml2:		cbr	temp1,0xf0
		ldi	zl,low(2*char_tab)
		lsl	temp1
		add	zl,temp1
		lsl	temp1
		add	zl,temp1
		ldd	temp1,y+col_index
		add	zl,temp1
		clr	zh
		lpm
		mov	zl,wl
disp_digit:	mov	zh,wl		
		cbr	zl,0x0b
		sbr	zh,0x74
		clt
		brtc	PC
		out	portb,zl
		out	portd,zh
		ldd	zl,y+dot_w
		lsr	zl
		lsr	zl
	;	inc	zl
	;	ldi	zl,0x10
dd1:		clt
		brtc	PC
		dec	zl
		brne	dd1		
		inc	temp1
		std	y+col_index,temp1
		cpi	temp1,6
		breq	dd2
		rjmp	start
dd2:		std	y+col_index,yh
inc_block:	ldd	zl,y+block_index
		inc	zl
		std	y+block_index,zl
		rjmp	start





inc_tenm:	ldd	temp1,y+minutes
		subi	temp1,-0x10
		cpi	temp1,0x60
		brmi	returnt
		cbr	temp1,0xF0
		std	y+minutes,temp1
		rjmp	inc_hours
returnt:	std	y+minutes,temp1
		ret
inc_mins:	ldd	temp1,y+minutes
		subi	temp1,-7
		brhc	sixty
		subi	temp1,6
returnm:	std	y+minutes,temp1
		ret
sixty:		cpi	temp1,0x60
		brne	returnm
		std	y+minutes,yh
inc_hours:	ldd	temp1,y+hours
		cpi	temp1,0x12
		breq	hour1
		subi	temp1,-7
		brhc	returnh
		subi	temp1,6
returnh:	std	y+hours,temp1
		ret
hour1:		ldi	temp1,1
		std	y+hours,temp1
		ret


